package demo.client.login;

import com.google.gwt.user.client.rpc.AsyncCallback;

import demo.client.Environment;
import demo.client.Presenter;
import demo.client.SimpleCallback;
import demo.client.dtos.UserPassKeyDto;
import demo.client.rpc.LoginServiceAsync;

public class LoginFormPresenter extends Presenter<LoginFormDisplay> {
	public static String PLACE = "login";

	LoginServiceAsync loginService;
	SimpleCallback<UserPassKeyDto> loginSuccessCallback;

	public LoginFormPresenter(final String params, final LoginFormDisplay loginDisplay, final Environment environment, final SimpleCallback<UserPassKeyDto> callback) {

		super(params, loginDisplay, environment);
		loginSuccessCallback = callback;
		loginService = getEnvironment().getModel().getRemoteLoginService();

		loginDisplay.setName("marcin");
		loginDisplay.setPassword("");
		loginDisplay.setLoginCallback(new SimpleCallback<Object>() {
			@Override
			public void goBack(final Object result) {
				final String name = LoginFormPresenter.this.getDisplay().getName();
				final String pass = LoginFormPresenter.this.getDisplay().getPassword();

				loginService.login(name, pass, new AsyncCallback<Void>() {
					public void onFailure(final Throwable caught) {
						LoginFormPresenter.this.getEnvironment().showAlert("Failed login");
						loginSuccessCallback.onFailure(new Throwable());
					}

					public void onSuccess(final Void result) {
						UserPassKeyDto tmp = new UserPassKeyDto();
						tmp.user = "marcin";
						tmp.pass = "enter";
						loginSuccessCallback.goBack(tmp);
					}

				});
			}
		});
	}
}
